## ncbi-blast+ 2.7.1

=== c++/src/CMakeLists.txt ===
##############################################################################
# CMakeLists.txt autogenerated from /net/nasan50/vol/gpipe_dev/dicuccio/cpp-toolkit/cpp-cmake/src/Makefile.in
#

# We require at least cmake-3.0
cmake_minimum_required(VERSION 3.0)

project(CPP)

include(build-system/cmake/CMakeMacros.cmake)
include(build-system/cmake/CMakeChecks.cmake)
# Include projects from this directory

# Recurse subdirectories
add_subdirectory(corelib)
add_subdirectory(util)
add_subdirectory(connect)
add_subdirectory(cgi)
add_subdirectory(html)
add_subdirectory(build-system)
add_subdirectory(serial)
add_subdirectory(db)
add_subdirectory(dbapi)
add_subdirectory(objects)
add_subdirectory(objmgr)
add_subdirectory(objtools)
add_subdirectory(ctools)
add_subdirectory(algo)
add_subdirectory(misc)
add_subdirectory(sra)
add_subdirectory(app)

add_subdirectory_optional(gui)
add_subdirectory_optional(sample)
add_subdirectory_optional(internal)

## # Legacy targets from old build system
## add_custom_target(all_f DEPENDS all)
## add_custom_target(all_r DEPENDS all)
## add_custom_target(all_p DEPENDS all)

=== c++/src/algo/CMakeLists.txt ===
##############################################################################
# CMakeLists.txt autogenerated from /export/home/dicuccio/cpp-cmake/cpp-cmake/src/algo/Makefile.in
#

# Include projects from this directory

# Recurse subdirectories
add_subdirectory_optional(align)
add_subdirectory_optional(blast)
add_subdirectory_optional(cobalt)
add_subdirectory_optional(dustmask)
add_subdirectory_optional(gnomon)
add_subdirectory_optional(id_mapper)
add_subdirectory_optional(ms)
add_subdirectory_optional(phy_tree)
add_subdirectory_optional(primer)
add_subdirectory_optional(segmask)
add_subdirectory_optional(seqqa)
add_subdirectory_optional(sequence)
add_subdirectory_optional(structure)
add_subdirectory_optional(text)
add_subdirectory_optional(tree)
add_subdirectory_optional(volume_merge)
add_subdirectory_optional(winmask)

=== c++/src/app/CMakeLists.txt ===
##############################################################################
# CMakeLists.txt autogenerated from /export/home/dicuccio/cpp-cmake/cpp-cmake/src/app/Makefile.in
#

# Include projects from this directory

# Recurse subdirectories
add_subdirectory_optional(agp_validate)
add_subdirectory_optional(agpconvert)
add_subdirectory_optional(annotwriter)
add_subdirectory_optional(asn2asn)
add_subdirectory_optional(asn2fasta)
add_subdirectory_optional(asn2flat)
add_subdirectory_optional(asn_cache)
add_subdirectory_optional(asn_cleanup)
add_subdirectory_optional(asnval)
add_subdirectory_optional(bdb_env_keeper)
add_subdirectory_optional(biosample_chk)
add_subdirectory_optional(blast)
add_subdirectory_optional(blastdb)
add_subdirectory_optional(compart)
add_subdirectory_optional(convert_seq)
add_subdirectory_optional(discrepancy_report)
add_subdirectory_optional(dustmasker)
add_subdirectory_optional(formatguess)
add_subdirectory_optional(gap_stats)
add_subdirectory_optional(gi2taxid)
add_subdirectory_optional(grid)
add_subdirectory_optional(hfilter)
add_subdirectory_optional(id1_fetch)
add_subdirectory_optional(id2_fetch)
add_subdirectory_optional(idfetch)
add_subdirectory_optional(idmapper)
add_subdirectory_optional(igblast)
add_subdirectory_optional(lds2_indexer)
add_subdirectory_optional(multireader)
add_subdirectory_optional(ncbi_encrypt)
add_subdirectory_optional(netschedule)
add_subdirectory_optional(netstorage)
add_subdirectory_optional(nmer_repeats)
add_subdirectory_optional(nw_aligner)
add_subdirectory_optional(objextract)
add_subdirectory_optional(objmgr)
add_subdirectory_optional(read_blast_result)
add_subdirectory_optional(segmasker)
add_subdirectory_optional(speedtest)
add_subdirectory_optional(splign)
add_subdirectory_optional(srcchk)
add_subdirectory_optional(ssub_fork)
add_subdirectory_optional(streamtest)
add_subdirectory_optional(table2asn)
add_subdirectory_optional(tableval)
add_subdirectory_optional(vecscreen)
add_subdirectory_optional(winmasker)

=== c++/src/build-system/CMakeLists.txt ===
##############################################################################
# 
#

# Include projects from this directory

# Recurse subdirectories
add_subdirectory(project_tree_builder)
#add_subdirectory(helpers)

=== c++/src/cgi/CMakeLists.txt ===
##############################################################################
# 
#

# Include projects from this directory
include(CMakeLists.cgi.lib.txt)
if (FastCGI_FOUND)
    include(CMakeLists.fcgi.lib.txt)
endif()

# Recurse subdirectories
add_subdirectory(test )

=== c++/src/connect/CMakeLists.txt ===
##############################################################################
# 
#

#
# The connect library uses a split between a shared C toolkit library and an
# independent C++ toolkit library
# These variables capture the split

if (UNIX)
    set(os_src ${LOCAL_LBSM})
elseif (WIN32)
    set(os_src ncbi_lbsmd_stub ncbi_strerror)
endif()


set(SRC_TLS ncbi_gnutls ncbi_mbedtls ncbi_tls
    mbedtls/aes mbedtls/aesni mbedtls/arc4 mbedtls/asn1parse
    mbedtls/asn1write mbedtls/base64 mbedtls/bignum mbedtls/blowfish
    mbedtls/camellia mbedtls/ccm mbedtls/cipher mbedtls/cipher_wrap
    mbedtls/cmac mbedtls/ctr_drbg mbedtls/des mbedtls/dhm mbedtls/ecdh
    mbedtls/ecdsa mbedtls/ecjpake mbedtls/ecp mbedtls/ecp_curves
    mbedtls/entropy mbedtls/entropy_poll mbedtls/error mbedtls/gcm
    mbedtls/havege mbedtls/hmac_drbg mbedtls/md mbedtls/md2
    mbedtls/md4 mbedtls/mbedtls_md5 mbedtls/md_wrap
    mbedtls/memory_buffer_alloc mbedtls/oid mbedtls/padlock
    mbedtls/pem mbedtls/pk mbedtls/pk_wrap mbedtls/pkcs12
    mbedtls/pkcs5 mbedtls/pkparse mbedtls/pkwrite mbedtls/platform
    mbedtls/ripemd160 mbedtls/rsa mbedtls/sha1 mbedtls/sha256
    mbedtls/sha512 mbedtls/threading mbedtls/timing
    mbedtls/mbedtls_version mbedtls/version_features mbedtls/xtea
    mbedtls/certs mbedtls/pkcs11 mbedtls/x509 mbedtls/x509_create
    mbedtls/x509_crl mbedtls/x509_crt mbedtls/x509_csr
    mbedtls/x509write_crt mbedtls/x509write_csr
    mbedtls/debug mbedtls/net_sockets mbedtls/ssl_cache
    mbedtls/ssl_ciphersuites mbedtls/ssl_cli mbedtls/ssl_cookie
    mbedtls/ssl_srv mbedtls/ssl_ticket mbedtls/ssl_tls

    ncbi_gnutls ncbi_mbedtls ncbi_tls
    mbedtls/aes mbedtls/aesni mbedtls/arc4 mbedtls/asn1parse
    mbedtls/asn1write mbedtls/base64 mbedtls/bignum mbedtls/blowfish
    mbedtls/camellia mbedtls/ccm mbedtls/cipher mbedtls/cipher_wrap
    mbedtls/cmac mbedtls/ctr_drbg mbedtls/des mbedtls/dhm mbedtls/ecdh
    mbedtls/ecdsa mbedtls/ecjpake mbedtls/ecp mbedtls/ecp_curves
    mbedtls/entropy mbedtls/entropy_poll mbedtls/error mbedtls/gcm
    mbedtls/havege mbedtls/hmac_drbg mbedtls/md mbedtls/md2
    mbedtls/md4 mbedtls/mbedtls_md5 mbedtls/md_wrap
    mbedtls/memory_buffer_alloc mbedtls/oid mbedtls/padlock
    mbedtls/pem mbedtls/pk mbedtls/pk_wrap mbedtls/pkcs12
    mbedtls/pkcs5 mbedtls/pkparse mbedtls/pkwrite mbedtls/platform
    mbedtls/ripemd160 mbedtls/rsa mbedtls/sha1 mbedtls/sha256
    mbedtls/sha512 mbedtls/threading mbedtls/timing
    mbedtls/mbedtls_version mbedtls/version_features mbedtls/xtea
    mbedtls/certs mbedtls/pkcs11 mbedtls/x509 mbedtls/x509_create
    mbedtls/x509_crl mbedtls/x509_crt mbedtls/x509_csr
    mbedtls/x509write_crt mbedtls/x509write_csr
    mbedtls/debug mbedtls/net_sockets mbedtls/ssl_cache
    mbedtls/ssl_ciphersuites mbedtls/ssl_cli mbedtls/ssl_cookie
    mbedtls/ssl_srv mbedtls/ssl_ticket mbedtls/ssl_tls
    )

set(SRC_C
    ncbi_ansi_ext ncbi_buffer ncbi_types ncbi_priv ncbi_core ncbi_util
    ncbi_socket ncbi_connutil ncbi_connection ncbi_connector
    ncbi_socket_connector ncbi_file_connector ncbi_http_connector
    ncbi_memory_connector ncbi_heapmgr ncbi_server_info ncbi_service
    ncbi_host_info ncbi_dispd ncbi_service_connector ncbi_sendmail
    ncbi_ftp_connector ncbi_lb ncbi_local ncbi_base64 ncbi_version
    ncbi_lbos ncbi_namerd parson ncbi_ipv6 ncbi_iprange ncbi_localip
    ${os_src}
    )

set(SRC_CXX
    ncbi_socket_cxx ncbi_core_cxx email_diag_handler
    ncbi_conn_streambuf ncbi_conn_stream ncbi_conn_test
    ncbi_misc ncbi_namedpipe ncbi_namedpipe_connector
    ncbi_pipe ncbi_pipe_connector ncbi_conn_reader_writer
    ncbi_userhost ncbi_http_session ncbi_lbos_cxx ncbi_monkey
    ${SRC_TLS}
    )


# Include projects from this directory
include(CMakeLists.connect.lib.txt)
include(CMakeLists.connssl.lib.txt)
include(CMakeLists.xxconnect.lib.txt)
include(CMakeLists.xconnect.lib.txt)
include(CMakeLists.xthrserv.lib.txt)

# Recurse subdirectories
add_subdirectory(services)
add_subdirectory(ext)
add_subdirectory(test )
add_subdirectory(daemons)

=== c++/src/corelib/CMakeLists.txt ===
##############################################################################
# 
#

# Include projects from this directory
include(CMakeLists.corelib.lib.txt)
include(CMakeLists.test_mt.lib.txt)
include(CMakeLists.test_boost.lib.txt)

# Recurse subdirectories
add_subdirectory(test )

=== c++/src/db/CMakeLists.txt ===
##############################################################################
# 
#

# Include projects from this directory

# Recurse subdirectories
add_subdirectory(sqlite)
add_subdirectory(bdb)

=== c++/src/dbapi/CMakeLists.txt ===
##############################################################################
# 
#
if (APPLE)
  #set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wl,-framework,ApplicationServices -liconv")
  #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,-framework,ApplicationServices -liconv")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-framework,ApplicationServices -liconv")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-framework,ApplicationServices -liconv -undefined dynamic_lookup")
endif (APPLE)

# Include projects from this directory
include(CMakeLists.dbapi.lib.txt)

# Recurse subdirectories
add_subdirectory(driver)
add_subdirectory(simple)
add_subdirectory(cache)
add_subdirectory(lang_bind)
add_subdirectory(test)

=== c++/src/html/CMakeLists.txt ===
##############################################################################
# 
#

# Include projects from this directory
include(CMakeLists.html.lib.txt)

# Recurse subdirectories
add_subdirectory(test )
add_subdirectory(demo )

=== c++/src/misc/CMakeLists.txt ===
##############################################################################
# CMakeLists.txt autogenerated from /export/home/dicuccio/cpp-cmake/cpp-cmake/src/misc/Makefile.in
#

# Include projects from this directory

# Recurse subdirectories
add_subdirectory_optional(third_party)
add_subdirectory_optional(third_party_static)
add_subdirectory_optional(clog)
add_subdirectory_optional(grid_cgi)
add_subdirectory_optional(xmlwrapp)
add_subdirectory_optional(eutils_client)
add_subdirectory_optional(hydra_client)
add_subdirectory_optional(discrepancy)
add_subdirectory_optional(xmlreaders)
add_subdirectory_optional(hgvs)
add_subdirectory_optional(netstorage)
add_subdirectory_optional(jsonwrapp)
add_subdirectory_optional(biosample_util)
add_subdirectory_optional(data_loaders_util)

if (LAPACK_FOUND)
    add_subdirectory_optional(lapackwrapp)
endif()

=== c++/src/objects/CMakeLists.txt ===
##############################################################################
# 
#

# Include projects from this directory

# Recurse subdirectories
add_subdirectory(access)
add_subdirectory(biblio)
add_subdirectory(biotree)
add_subdirectory(blast)
add_subdirectory(blastdb)
add_subdirectory(blastxml)
add_subdirectory(blastxml2)
add_subdirectory(cdd)
add_subdirectory(cn3d)
add_subdirectory(coords)
add_subdirectory(docsum)
add_subdirectory(entrez2)
add_subdirectory(entrezgene)
add_subdirectory(featdef)
add_subdirectory(gbproj)
add_subdirectory(gbseq)
add_subdirectory(general)
add_subdirectory(genesbyloc)
add_subdirectory(genomecoll)
add_subdirectory(homologene)
add_subdirectory(id1)
add_subdirectory(id2)
add_subdirectory(insdseq)
add_subdirectory(macro)
add_subdirectory(medlars)
add_subdirectory(medline)
add_subdirectory(mim)
add_subdirectory(mla)
add_subdirectory(mmdb)
add_subdirectory(ncbimime)
add_subdirectory(objprt)
add_subdirectory(omssa)
add_subdirectory(pcassay)
add_subdirectory(pcsubstance)
add_subdirectory(proj)
add_subdirectory(pub)
add_subdirectory(pubmed)
add_subdirectory(remap)
add_subdirectory(scoremat)
add_subdirectory(seq)
add_subdirectory(seqcode)
add_subdirectory(seqedit)
add_subdirectory(seqset)
add_subdirectory(seqsplit)
add_subdirectory(seqtest)
add_subdirectory(submit)
add_subdirectory(taxon1)
add_subdirectory(taxon3)
add_subdirectory(tinyseq)
add_subdirectory(trackmgr)
add_subdirectory(valerr)
add_subdirectory(valid)
add_subdirectory(variation)
add_subdirectory(varrep)

#
# ASN dependencies:
# All centralized below
#

add_dependencies(biblio general-lib)
add_dependencies(biotree seq)
add_dependencies(blastdb seq)
add_dependencies(cdd general-lib biblio pub seqset seq mmdb cn3d scoremat)
add_dependencies(entrezgene seq general-lib pub)
add_dependencies(gbseq seq)
add_dependencies(gencoll_client genome_collection)
add_dependencies(genome_collection general-lib seq)
add_dependencies(homologene general-lib seq)
add_dependencies(id1 seq seqset)
add_dependencies(id2 seqsplit seq)
add_dependencies(medlars general-lib biblio)
add_dependencies(medline general-lib biblio)
add_dependencies(mla biblio medline medlars pubmed pub)
add_dependencies(mmdb general-lib pub biblio seqset seq)
add_dependencies(ncbimime general-lib biblio pub medline seq seqset mmdb cn3d cdd)
add_dependencies(omssa seq)
add_dependencies(pcassay general-lib pub seq pcsubstance)
add_dependencies(pcsubstance general-lib pub)
add_dependencies(proj general-lib biblio pubmed seq seqset)
add_dependencies(pub general-lib biblio medline)
add_dependencies(pubmed general-lib biblio medline)
add_dependencies(remap seq)
add_dependencies(scoremat seqset general-lib)
add_dependencies(seqedit seq)
add_dependencies(seq general-lib pub biblio)
add_dependencies(seqset general-lib biblio medline seq)
add_dependencies(seqsplit seq)
add_dependencies(seqtest general-lib seq)
add_dependencies(submit general-lib biblio seq seqset)
add_dependencies(taxon1 seq)
add_dependencies(taxon3 seq)
add_dependencies(trackmgr seq)
add_dependencies(variation seq)
add_dependencies(xnetblast seqset scoremat seq)

=== debian/changelog ===
ncbi-blast+ (2.7.1-2) unstable; urgency=medium

  [ David Miguel Susano Pinto ]
  * d/control: fix Vcs-* links to point to salsa

  [ Aaron M. Ucko ]
  * d/control: Standards-Version: 4.2.1 (already compliant).
  * d/patches/support_boost_1_67: New patch to extend Boost support
    (used for uninstalled tests) through at least version 1.67, per
    upstream (https://www.ncbi.nlm.nih.gov/viewvc/v1/trunk/c%2B%2B)
    revisions 79910, 79926, 79928, and 79929.  (Closes: #916000.)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 12 Dec 2018 22:24:45 -0500

ncbi-blast+ (2.7.1-1) unstable; urgency=medium

  * New upstream release
    d/patches: update patch for new release
    d/control:
      go to standards 4.1.3
      add mbedtls dependency

 -- Olivier Sallou <osallou@debian.org>  Sat, 10 Feb 2018 17:35:31 +0000

=== debian/control ===
Source: ncbi-blast+
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Olivier Sallou <osallou@debian.org>,
           Andreas Tille <tille@debian.org>,
	   Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: autotools-dev,
               debhelper (>= 9),
               libboost-test-dev,
               libbz2-dev,
               libc-dev-bin,
               libgnutls28-dev,
               libmbedtls-dev,
               libpcre3-dev,
               time,
               zlib1g-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/med-team/ncbi-blastplus
Vcs-Git: https://salsa.debian.org/med-team/ncbi-blastplus.git
Homepage: http://www.ncbi.nlm.nih.gov/IEB/ToolBox/CPP_DOC/

Package: ncbi-blast+
Architecture: any
Multi-Arch: foreign
Depends: ncbi-data,
         python,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Enhances: t-coffee
Description: next generation suite of BLAST sequence search tools
 The Basic Local Alignment Search Tool (BLAST) is the most widely
 used sequence similarity tool. There are versions of BLAST that
 compare protein queries to protein databases, nucleotide queries
 to nucleotide databases, as well as versions that translate nucleotide
 queries or databases in all six frames and compare to protein databases
 or queries.
 PSI-BLAST produces a position-specific-scoring-matrix (PSSM) starting
 with a protein query, and then uses that PSSM to perform further searches.
 It is also possible to compare a protein or nucleotide query to a
 database of PSSM’s.
 The NCBI supports a BLAST web page at blast.ncbi.nlm.nih.gov as well as
 a network service.

Package: ncbi-blast+-legacy
Architecture: all
Multi-Arch: foreign
Depends: ncbi-blast+,
         ${misc:Depends}
Breaks: blast2 (<< 1:2.5.0~)
Replaces: blast2 (<< 1:2.5.0~)
Description: NCBI Blast legacy call script
 This package adds some fake scripts to call NCBI+ programs
 with the NCBI blast command line. It makes use of the
 legacy_blast script in ncbi-blast+ package.

Package: blast2
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Priority: optional
Depends: ncbi-blast+-legacy,
         ${misc:Depends}
Description: transitional dummy package to ncbi-blast+-legacy
 This is a transitional dummy package for ncbi-blast+-legacy.
 It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

NUMJOBS=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif


DEB_CONFIGURE_EXTRA_FLAGS=--with-dll --with-mt --without-autodep \
    --without-makefile-auto-update --with-flat-makefile --without-caution \
    --without-dbapi --without-lzo --with-runpath=/usr/lib/ncbi-blast+ \
    --with-build-root=BUILD --without-debug --without-downloaded-vdb \
    --with-mbedtls
proj=algo/blast/ app/ objmgr/ objtools/align_format/ objtools/blast/

#ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
DEB_CONFIGURE_EXTRA_FLAGS += --with-symbols
#endif

#export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND=-Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

CFLAGS   := $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
CXXFLAGS := $(CXXFLAGS:-O%=-O)
DEB_CONFIGURE_EXTRA_FLAGS += FAST_CXXFLAGS=-O
endif

export CFLAGS CPPFLAGS CXXFLAGS LDFLAGS MAKE

# used for run_with_lock
DEB_CONFIGURE_EXTRA_FLAGS +=  CFLAGS_FOR_BUILD="$(CFLAGS) -fPIE"
DEB_CONFIGURE_EXTRA_FLAGS += LDFLAGS_FOR_BUILD="$(LDFLAGS)"

BLAST2_VERSION=1:$(shell dpkg-parsechangelog | awk '/^Version:/ { print $$2 }')

llp=LD_LIBRARY_PATH
override_dh_auto_configure:
	cd c++  &&  $(llp)=$(CURDIR)/c++/BUILD/lib$${$(llp)+:$$$(llp)} \
	    CONFIG_SHELL=/bin/bash ./configure $(DEB_CONFIGURE_EXTRA_FLAGS) \
	    ||  (tail -v -n +0 config.log BUILD/status/config.log; exit 1)

override_dh_auto_build-arch:
	cd c++/BUILD/build  && \
	    make -j$(NUMJOBS) -f Makefile.flat all_projects="$(proj)"
#	   make all_r

override_dh_auto_build-indep:
	echo "Save time and do nothing for architecture independent builds"

override_dh_auto_test:
	-dh_auto_test
	-c++/BUILD/build/check.sh concat_err
	-cat c++/BUILD/build/check.sh.out_err

instroot = debian/ncbi-blast+/usr
leg_bin = debian/ncbi-blast+-legacy/usr/bin
override_dh_auto_install-arch:
	# cp c++/BUILD/lib/*.so $(instroot)/lib/ncbi-blast+/
	cp c++/BUILD/bin/*    $(instroot)/bin/

override_dh_auto_install-indep:
	echo "Nothing to do for architecture independant installs"

override_dh_install-arch:
	# dh_install
	mv $(instroot)/bin/rpsblast $(instroot)/bin/rpsblast+
	mv $(instroot)/bin/seedtop $(instroot)/bin/seedtop+
	mv $(instroot)/bin/legacy_blast.pl   $(instroot)/bin/legacy_blast
	mv $(instroot)/bin/update_blastdb.pl $(instroot)/bin/update_blastdb
	mv $(instroot)/bin/windowmasker_2.2.22_adapter.py \
	   $(instroot)/bin/windowmasker_2.2.22_adapter
# Clean up tests, demos, and internal build tools
	rm -f $(instroot)/bin/*test* $(instroot)/bin/seqdb_demo \
	    $(instroot)/bin/datatool $(instroot)/bin/run_with_lock \
	    $(instroot)/bin/project_tree_builder
	for x in $(instroot)/bin/*; do \
	    LD_LIBRARY_PATH=c++/BUILD/lib ldd $$x; \
	done 2>/dev/null | awk '/BUILD/ { print $$3 }' | sort -u | \
	xargs cp -v -t $(instroot)/lib/ncbi-blast+

override_dh_install-indep:
	#if test -d $(leg_bin); then cp debian/legacy/legacy.sh $(leg_bin)/; fi
	for x in blastall megablast blastpgp bl2seq rpsblast fastacmd formatdb \
	         seedtop; do \
	    sed -e "s/.{.*}/$$x/" debian/legacy/legacy.sh > $(leg_bin)/$$x; \
	    chmod +x $(leg_bin)/$$x; \
	done

override_dh_clean:
	cp c++/configure.orig configure.orig.save
	dh_clean
	#Tricky - for each module directory there may be several module files
	#or there may be none but then there is still a module named after the
	#directory.  Clean everything!
	-for x in c++/src/objects/* ; do \
	    (cd "$$x"  && ( \
		mods="`echo *.module`" ; \
		[ "$${mods#*\*}" = "$$mods" ] || mods="`basename $$x`" ; \
		for mod in $$mods ; do \
       		    ../../../BUILD/build/new_module.sh $$mod purge_sources ; \
		done ) ; \
	    ) ; \
	done
	rm -rf c++/compilers/dll c++/config.log c++/Makefile
	rm -f c++/configure.lineno c++/src/objects/blastxml/blastxml.module
	find -name check_exec.pid -delete
	rm -rf c++/BUILD
	mv configure.orig.save c++/configure.orig

override_dh_gencontrol-indep:
	dh_gencontrol -pblast2 -- -v$(BLAST2_VERSION)
	dh_gencontrol -Nblast2

%:
	#dh $@ -Dc++ --with autotools_dev
	dh $@ -Dc++

## ncbi-blast+ 2.8.1

=== c++/src/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 575211 2018-11-26 16:41:56Z blastadm $
#############################################################################
##############################################################################

# We require at least cmake-3.0
cmake_minimum_required(VERSION 3.0)

if("${CMAKE_GENERATOR}" STREQUAL "Xcode")
    if(NOT DEFINED XCODE)
        set(XCODE ON)
    endif()
endif()

###############################################################################
# must be set to OFF on trunk
if(NOT DEFINED NCBI_EXPERIMENTAL)
  set(NCBI_EXPERIMENTAL OFF)
endif()

if (NOT DEFINED NCBI_CMAKEPROJECT_NAME)
  set(NCBI_CMAKEPROJECT_NAME CPP)
endif()

if("${NCBI_PTBCFG_PROJECT_LIST}" STREQUAL "")
    unset(NCBI_PTBCFG_PROJECT_LIST)
endif()
#  set(NCBI_PTBCFG_PROJECT_LIST     corelib serial build-system)
#  set(NCBI_PTBCFG_ALLOWED_PROJECTS project_tree_builder datatool)
#  set(NCBI_VERBOSE_ALLPROJECTS OFF)
#  set(NCBI_VERBOSE_PROJECTS xncbi variation_utils)

if(DEFINED NCBI_VERBOSE_PROJECTS)
  foreach(_prj IN LISTS NCBI_VERBOSE_PROJECTS)
    set(NCBI_VERBOSE_PROJECT_${_prj}   ON)
  endforeach()
endif()

set(NCBI_PTBCFG_KNOWN_FOLDERS
  corelib
  util
  connect
  cgi
  html
  build-system
  serial
  db
  dbapi
  objects
  objmgr
  objtools
  ctools
  algo
  misc
  sra
)


if(NCBI_EXPERIMENTAL)
  cmake_policy(SET CMP0054 NEW)

  set(NCBI_EXPERIMENTAL_CFG              ON)
  set(NCBI_EXPERIMENTAL_SUBDIRS          ON)
  set(NCBI_EXPERIMENTAL_DISABLE_HUNTER   ON)
  set(NCBI_VERBOSE_ALLPROJECTS           OFF)

  if(BUILD_SHARED_LIBS)
    if(WIN32 OR XCODE)
      set(NCBI_PTBCFG_COMPOSITE_DLL dll)
    endif()
  endif()

  if (DEFINED NCBI_PTBCFG_COMPOSITE_DLL OR DEFINED NCBI_PTBCFG_ALLOWED_PROJECTS OR DEFINED NCBI_PTBCFG_PROJECT_LIST)
    set(NCBI_PTBCFG_ENABLE_COLLECTOR ON)
  endif()

else()
  cmake_policy(SET CMP0054 OLD)

  set(NCBI_EXPERIMENTAL_CFG              OFF)
  set(NCBI_EXPERIMENTAL_SUBDIRS          OFF)
  set(NCBI_EXPERIMENTAL_DISABLE_HUNTER   OFF)
  set(NCBI_VERBOSE_ALLPROJECTS           OFF)
  set(NCBI_PTBCFG_ENABLE_COLLECTOR       OFF)
endif()

if(DEFINED NCBI_PTBCFG_PROJECT_LIST AND EXISTS "${NCBI_PTBCFG_PROJECT_LIST}")
  if (NOT IS_DIRECTORY "${NCBI_PTBCFG_PROJECT_LIST}")
    file(STRINGS "${NCBI_PTBCFG_PROJECT_LIST}" NCBI_PTBCFG_PROJECT_LIST)
  endif()
endif()

###############################################################################
if (OFF)
message("CMAKE_CONFIGURATION_TYPES: ${CMAKE_CONFIGURATION_TYPES}")
set(_cfg_types Debug Release MinSizeRel RelWithDebInfo)

message("")
message("CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
foreach(_cfg ${_cfg_types})
  string(TOUPPER ${_cfg} _upname)
  message("CMAKE_C_FLAGS_${_upname}: ${CMAKE_C_FLAGS_${_upname}}")
endforeach()

message("")
message("CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
foreach(_cfg ${_cfg_types})
  string(TOUPPER ${_cfg} _upname)
  message("CMAKE_CXX_FLAGS_${_upname}: ${CMAKE_CXX_FLAGS_${_upname}}")
endforeach()

message("")
message("CMAKE_STATIC_LINKER_FLAGS: ${CMAKE_STATIC_LINKER_FLAGS}")
foreach(_cfg ${_cfg_types})
  string(TOUPPER ${_cfg} _upname)
  message("CMAKE_STATIC_LINKER_FLAGS_${_upname}: ${CMAKE_STATIC_LINKER_FLAGS_${_upname}}")
endforeach()

message("")
message("CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS}")
foreach(_cfg ${_cfg_types})
  string(TOUPPER ${_cfg} _upname)
  message("CMAKE_EXE_LINKER_FLAGS_${_upname}: ${CMAKE_EXE_LINKER_FLAGS_${_upname}}")
endforeach()

message("")
message("CMAKE_MODULE_LINKER_FLAGS: ${CMAKE_MODULE_LINKER_FLAGS}")
foreach(_cfg ${_cfg_types})
  string(TOUPPER ${_cfg} _upname)
  message("CMAKE_MODULE_LINKER_FLAGS_${_upname}: ${CMAKE_MODULE_LINKER_FLAGS_${_upname}}")
endforeach()

message("")
message("CMAKE_SHARED_LINKER_FLAGS: ${CMAKE_SHARED_LINKER_FLAGS}")
foreach(_cfg ${_cfg_types})
  string(TOUPPER ${_cfg} _upname)
  message("CMAKE_SHARED_LINKER_FLAGS_${_upname}: ${CMAKE_SHARED_LINKER_FLAGS_${_upname}}")
endforeach()
#return()
endif()
###############################################################################
## Initialize Hunter
##
if (NOT NCBI_EXPERIMENTAL_DISABLE_HUNTER)
if (WIN32)
    if (NOT HUNTER_ROOT)
        set(HUNTER_ROOT ${CMAKE_SOURCE_DIR}/../HunterPackages)
    endif()
    include(build-system/cmake/HunterGate.cmake)
    HunterGate(
        URL "https://github.com/ruslo/hunter/archive/v0.18.39.tar.gz"
        SHA1 "a6fbc056c3d9d7acdaa0a07c575c9352951c2f6c"
    )
endif()
endif()


project(${NCBI_CMAKEPROJECT_NAME})

include(build-system/cmake/CMakeMacros.cmake)
include(build-system/cmake/CMake.NCBIptb.cmake)
include(build-system/cmake/CMakeChecks.cmake)

if (NOT NCBI_EXPERIMENTAL_CFG)
#
# NOTE NOTE NOTE
#
# The macros below are deliberately added here
# Including these in CMakeMacros.cmake causes these overrides to be used from
# within all package configuration processes
# That will result in tons of errors related to the use of add_library() from
# within other package specifications (i.e., Threads, Boost)
#
# LEAVE THESE HERE
#

##############################################################################
##
## Macro to force installation (recursively) for all include files in a
## directory
##
## Note: we call this with all top-level directories!
##

macro(ncbi_install_includes tag)
    #message(STATUS "Installing headers: ${tag}")
    install(
        DIRECTORY ${top_src_dir}/include/${tag}
        DESTINATION include
        COMPONENT   Devel
        FILES_MATCHING
        PATTERN "*.hpp"
        PATTERN "*.h"
        PATTERN "*.inc"
        PATTERN "*.inl"
        )
endmacro(ncbi_install_includes)


##############################################################################
##
## Override of add_library:
## We do this to force installation without having to explicitly add
## installation for all libraries

macro(add_library _libname)
    #message(STATUS "Adding library: ${_libname}")
    _add_library(${_libname} ${ARGN})
    install(
        TARGETS ${_libname}
        DESTINATION lib
        EXPORT ncbi-cpp-toolkit
        )
endmacro(add_library)


macro(add_executable _exename)
    #message(STATUS "Adding executable: ${_exename}")
    _add_executable(${_exename} ${ARGN})
    install(
        TARGETS ${_exename}
        DESTINATION bin
        EXPORT ncbi-cpp-toolkit
        )
endmacro(add_executable)

endif()
#
##############################################################################
#

# Recurse subdirectories
if (NCBI_EXPERIMENTAL_SUBDIRS)

NCBI_add_root_subdirectory( ${NCBI_PTBCFG_COMPOSITE_DLL}  ${NCBI_PTBCFG_KNOWN_FOLDERS})

else (NCBI_EXPERIMENTAL_SUBDIRS)

add_subdirectory(corelib)
add_subdirectory(util)
add_subdirectory(connect)
add_subdirectory(cgi)
add_subdirectory(html)
add_subdirectory(build-system)
add_subdirectory(serial)
add_subdirectory(db)
add_subdirectory(dbapi)
add_subdirectory(objects)
add_subdirectory(objmgr)
add_subdirectory(objtools)
add_subdirectory(ctools)
add_subdirectory(algo)
add_subdirectory(misc)
add_subdirectory(sra)
add_subdirectory(app)

add_subdirectory_optional(gui)
add_subdirectory_optional(sample)
add_subdirectory_optional(internal)

ncbi_install_includes(algo)
ncbi_install_includes(app)
ncbi_install_includes(build-system)
ncbi_install_includes(cgi)
ncbi_install_includes(common)
ncbi_install_includes(connect)
ncbi_install_includes(corelib)
ncbi_install_includes(ctools)
ncbi_install_includes(db)
ncbi_install_includes(dbapi)
ncbi_install_includes(gui)
ncbi_install_includes(html)
ncbi_install_includes(internal)
ncbi_install_includes(misc)
ncbi_install_includes(objects)
ncbi_install_includes(objmgr)
ncbi_install_includes(objtools)
ncbi_install_includes(serial)
ncbi_install_includes(sra)
ncbi_install_includes(util)


##############################################################################
#
# Special-purpose files to install
# There are just a few of these
#
install(
    FILES ${top_src_dir}/include/ncbi_pch.hpp
          ${top_src_dir}/include/ncbi_source_ver.h
          ${top_src_dir}/include/ncbiconf.h
    DESTINATION include
    COMPONENT   Devel
    )

install(
    FILES ${_os_specific_config}
    DESTINATION lib/cmake/ncbi-cpp-toolkit-${NCBI_CPP_TOOLKIT_VERSION}/include
    COMPONENT   Devel
    )


#
##############################################################################
#

#
# Package config and setup issues
# NOTE: This must come last!!
#
# This code is needed to make sure we can import the toolkit when the toolkit
# is packaged as a third-party component
#

include(CMakePackageConfigHelpers)

set(PACKAGE_INCLUDE_INSTALL_DIRS include)
set(PACKAGE_SITE_INCLUDE_INSTALL_DIRS lib/cmake/ncbi-cpp-toolkit-${NCBI_CPP_TOOLKIT_VERSION}/include)
set(PACKAGE_LIBRARY_INSTALL_DIRS lib)

# Compiler definitions require some magic
get_directory_property(Defs COMPILE_DEFINITIONS)
foreach (d ${Defs} )
    set(PACKAGE_COMPILE_DEFINITIONS "${PACKAGE_COMPILE_DEFINITIONS} -D${d}")
endforeach()


configure_package_config_file(
    "build-system/cmake/NCBI-ToolkitConfig.cmake.in"
    ${CMAKE_CURRENT_BINARY_DIR}/ncbi-cpp-toolkit-config.cmake
    INSTALL_DESTINATION lib/cmake/ncbi-cpp-toolkit-${NCBI_CPP_TOOLKIT_VERSION}
    PATH_VARS PACKAGE_INCLUDE_INSTALL_DIRS PACKAGE_LIBRARY_INSTALL_DIRS
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/ncbi-cpp-toolkit-config-version.cmake
    VERSION ${NCBI_CPP_TOOLKIT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/ncbi-cpp-toolkit-config.cmake
          ${CMAKE_CURRENT_BINARY_DIR}/ncbi-cpp-toolkit-config-version.cmake
    DESTINATION lib/cmake/ncbi-cpp-toolkit-${NCBI_CPP_TOOLKIT_VERSION}
)

install(EXPORT ncbi-cpp-toolkit
    DESTINATION lib/cmake/ncbi-cpp-toolkit-${NCBI_CPP_TOOLKIT_VERSION}
    )

endif (NCBI_EXPERIMENTAL_SUBDIRS)

=== c++/src/misc/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,17 @@
-##############################################################################
+#############################################################################
+# $Id: CMakeLists.txt 565539 2018-06-13 16:19:50Z gouriano $
+#############################################################################
+
+
+NCBI_add_subdirectory(
+  third_party third_party_static
+  clog grid_cgi xmlwrapp eutils_client hydra_client discrepancy
+  xmlreaders hgvs netstorage jsonwrapp biosample_util data_loaders_util
+  lapackwrapp cgi_redirect
+#  pmcidconv_client grpc_integration
+)
+
+if(OFF)
 # CMakeLists.txt autogenerated from /export/home/dicuccio/cpp-cmake/cpp-cmake/src/misc/Makefile.in
 #
 
@@ -23,3 +36,4 @@
 if (LAPACK_FOUND)
     add_subdirectory_optional(lapackwrapp)
 endif()
+endif()

=== c++/src/algo/segmask/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 566834 2018-07-09 12:39:41Z gouriano $
#############################################################################

NCBI_add_library(xalgosegmask)


# Include projects from this directory
#include(CMakeLists.xalgosegmask.lib.txt)

=== c++/src/objects/cn3d/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 564454 2018-05-29 13:35:44Z gouriano $
#############################################################################

NCBI_add_library(cn3d)

# Include projects from this directory
#include(CMakeLists.cn3d.asn.txt)

=== c++/src/objects/docsum/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 564454 2018-05-29 13:35:44Z gouriano $
#############################################################################

NCBI_add_library(docsum)

# Include projects from this directory
#include(CMakeLists.docsum.asn.txt)

=== c++/src/objects/entrez2/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 564454 2018-05-29 13:35:44Z gouriano $
#############################################################################

NCBI_add_library(entrez2 entrez2cli)
NCBI_add_subdirectory(demo)

# Include projects from this directory
#include(CMakeLists.entrez2cli.lib.txt)
#include(CMakeLists.entrez2.asn.txt)

# Recurse subdirectories
#add_subdirectory(demo )

=== c++/src/objects/entrezgene/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 564454 2018-05-29 13:35:44Z gouriano $
#############################################################################

NCBI_add_library(entrezgene)

# Include projects from this directory
#include(CMakeLists.entrezgene.asn.txt)

=== c++/src/objects/gbproj/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 564454 2018-05-29 13:35:44Z gouriano $
#############################################################################

NCBI_add_library(gbproj)

# Include projects from this directory
#include(CMakeLists.gbproj.asn.txt)

=== c++/src/objects/mmdb/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 564454 2018-05-29 13:35:44Z gouriano $
#############################################################################

NCBI_add_library(mmdb)

# Include projects from this directory
#include(CMakeLists.mmdb.lib.txt)

=== c++/src/objects/proj/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 564454 2018-05-29 13:35:44Z gouriano $
#############################################################################

NCBI_add_library(proj)

# Include projects from this directory
#include(CMakeLists.proj.asn.txt)

=== c++/src/objtools/blast/blastdb_format/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 566390 2018-06-28 17:11:39Z gouriano $
#############################################################################

NCBI_add_library(blastdb_format)
NCBI_add_subdirectory(unit_test)

# Include projects from this directory
#include(CMakeLists.blastdb_format.lib.txt)

# Recurse subdirectories
#add_subdirectory(unit_test )

=== c++/src/objtools/blast/gene_info_reader/unit_test/CMakeLists.txt ===
#############################################################################
# $Id: CMakeLists.txt 566390 2018-06-28 17:11:39Z gouriano $
#############################################################################

NCBI_project_tags(test)
NCBI_requires(Boost.Test.Included)
NCBI_add_app(gene_info_unit_test)

if(OFF)
# Include projects from this directory
if (UNIX AND NOT APPLE)
include(CMakeLists.gene_info_unit_test.app.txt)
endif()
endif()

=== debian/changelog ===
ncbi-blast+ (2.8.1-2) unstable; urgency=medium

  * Convert windowmasker_2.2.22_adapter to Python 3 via 2to3;
    update (build-)dependencies accordingly.  (Closes: #937121.)

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 01 Sep 2019 20:50:43 -0400

ncbi-blast+ (2.8.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/compat: Advance to Debhelper 11.
  * debian/control:
    - Build-Depend on liblmdb-dev.
    - Split B-Ds other than Debhelper out to Build-Depends-Arch.
    - Advance Debhelper requirement to 11~.
    - Standards-Version: 4.3.0 (already compliant).
    - Rules-Requires-Root: no.
  * debian/patches: Formally update for new release.
    - Retire support_boost_1_67 (already applied upstream).
    - Update patches that apply with offsets or outright fuzz, or need
      full-fledged porting.
  * debian/patches/fix_lib_deps: Link xcleanup against $(OBJEDIT_LIBS).
  * debian/patches/system_mbedtls_only (new): Omit convenience mbed TLS
    copy, which is dead weight and yielded a Lintian error.
  * debian/rules: Also skip (dh_auto)_configure when building only
    architecture-independent binary packages.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 03 Feb 2019 22:47:45 -0500

=== debian/control ===
--- 
+++ 
@@ -5,26 +5,29 @@
 	   Aaron M. Ucko <ucko@debian.org>
 Section: science
 Priority: optional
-Build-Depends: autotools-dev,
-               debhelper (>= 9),
+Build-Depends: debhelper (>= 11~)
+Build-Depends-Arch: 2to3,
+               autotools-dev,
                libboost-test-dev,
                libbz2-dev,
                libc-dev-bin,
                libgnutls28-dev,
+	       liblmdb-dev,
                libmbedtls-dev,
                libpcre3-dev,
                time,
                zlib1g-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/med-team/ncbi-blastplus
 Vcs-Git: https://salsa.debian.org/med-team/ncbi-blastplus.git
 Homepage: http://www.ncbi.nlm.nih.gov/IEB/ToolBox/CPP_DOC/
+Rules-Requires-Root: no
 
 Package: ncbi-blast+
 Architecture: any
 Multi-Arch: foreign
 Depends: ncbi-data,
-         python,
+         python3,
          ${misc:Depends},
          ${perl:Depends},
          ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -47,7 +47,8 @@
 BLAST2_VERSION=1:$(shell dpkg-parsechangelog | awk '/^Version:/ { print $$2 }')
 
 llp=LD_LIBRARY_PATH
-override_dh_auto_configure:
+override_dh_auto_configure-indep:;
+override_dh_auto_configure-arch:
 	cd c++  &&  $(llp)=$(CURDIR)/c++/BUILD/lib$${$(llp)+:$$$(llp)} \
 	    CONFIG_SHELL=/bin/bash ./configure $(DEB_CONFIGURE_EXTRA_FLAGS) \
 	    ||  (tail -v -n +0 config.log BUILD/status/config.log; exit 1)
@@ -80,8 +81,11 @@
 	mv $(instroot)/bin/seedtop $(instroot)/bin/seedtop+
 	mv $(instroot)/bin/legacy_blast.pl   $(instroot)/bin/legacy_blast
 	mv $(instroot)/bin/update_blastdb.pl $(instroot)/bin/update_blastdb
-	mv $(instroot)/bin/windowmasker_2.2.22_adapter.py \
-	   $(instroot)/bin/windowmasker_2.2.22_adapter
+	sed -e '1s/$$/3/' $(instroot)/bin/windowmasker_2.2.22_adapter.py \
+	   > $(instroot)/bin/windowmasker_2.2.22_adapter
+	2to3 -w $(instroot)/bin/windowmasker_2.2.22_adapter
+	chmod +x $(instroot)/bin/windowmasker_2.2.22_adapter
+	rm $(instroot)/bin/windowmasker_2.2.22_adapter.py
 # Clean up tests, demos, and internal build tools
 	rm -f $(instroot)/bin/*test* $(instroot)/bin/seqdb_demo \
 	    $(instroot)/bin/datatool $(instroot)/bin/run_with_lock \
